# tkinter_tab_more/__init__.py

# Window Manager Protocols
WM_DELETE_WINDOW = "WM_DELETE_WINDOW"
"""WM_DELETE_WINDOW: 窗口关闭协议常量 / Window close protocol constant"""

WM_PROTOCOL_MESSAGE = "WM_PROTOCOL_MESSAGE"
"""WM_PROTOCOL_MESSAGE: 窗口管理器通信消息 / Window manager communication message"""


# Drag and Drop (Xdnd)
XdndEnter = "XdndEnter"
"""XdndEnter: 拖放进入窗口事件 / Drag enters the window"""

XdndPosition = "XdndPosition"
"""XdndPosition: 拖放位置更新事件 / Drag position update event"""

XdndDrop = "XdndDrop"
"""XdndDrop: 拖放释放事件 / Drop event"""

XdndStatus = "XdndStatus"
"""XdndStatus: 拖放状态反馈事件 / Drag status feedback event"""

XdndLeave = "XdndLeave"
"""XdndLeave: 拖放离开窗口事件 / Drag leaves the window"""

XdndFinished = "XdndFinished"
"""XdndFinished: 拖放结束事件 / Drag finished event"""

XdndSelection = "XdndSelection"
"""XdndSelection: 拖放数据请求事件 / Drag data request event"""

XdndActionCopy = "XdndActionCopy"
"""XdndActionCopy: 拖放复制操作 / Copy action in drag and drop"""

XdndActionMove = "XdndActionMove"
"""XdndActionMove: 拖放移动操作 / Move action in drag and drop"""

XdndActionLink = "XdndActionLink"
"""XdndActionLink: 拖放链接操作 / Link action in drag and drop"""

XdndActionAsk = "XdndActionAsk"
"""XdndActionAsk: 拖放询问用户操作 / Ask user action in drag and drop"""


# Clipboard
CLIPBOARD = "CLIPBOARD"
"""CLIPBOARD: 系统剪贴板名称 / System clipboard name"""

PRIMARY = "PRIMARY"
"""PRIMARY: 主选剪贴板名称（X11） / Primary selection clipboard (X11)"""

TARGETS = "TARGETS"
"""TARGETS: 剪贴板数据类型列表 / Clipboard data type list"""


# Virtual Events
VIRTUAL_EVENT_PREFIX = "<<"
"""VIRTUAL_EVENT_PREFIX: 虚拟事件前缀 / Prefix for virtual events"""

VIRTUAL_EVENT_SUFFIX = ">>"
"""VIRTUAL_EVENT_SUFFIX: 虚拟事件后缀 / Suffix for virtual events"""


# Tk versions
TK_VERSION = "tk_version"
"""TK_VERSION: Tk 当前版本号字符串 / Current Tk version string"""

TK_PATCHLEVEL = "tk_patchLevel"
"""TK_PATCHLEVEL: Tk 补丁级别 / Tk patch level"""


# File types for file dialogs
FILE_TYPES_ALL = "*.*"
"""FILE_TYPES_ALL: 所有文件类型 / All file types"""

FILE_TYPES_TEXT = "*.txt"
"""FILE_TYPES_TEXT: 文本文件类型 / Text file type (*.txt)"""

FILE_TYPES_PYTHON = "*.py"
"""FILE_TYPES_PYTHON: Python 源文件类型 / Python source file type (*.py)"""

FILE_TYPES_IMAGE = "*.png *.jpg *.jpeg *.gif *.bmp"
"""FILE_TYPES_IMAGE: 图像文件类型 / Image file types (*.png, *.jpg, etc.)"""

FILE_TYPES_JSON = "*.json"
"""FILE_TYPES_JSON: JSON 数据文件类型 / JSON data file type (*.json)"""

FILE_TYPES_CSV = "*.csv"
"""FILE_TYPES_CSV: CSV 表格文件类型 / CSV table file type (*.csv)"""


# Mouse cursors
CURSOR_ARROW = "arrow"
"""CURSOR_ARROW: 箭头光标 / Arrow cursor"""

CURSOR_HAND = "hand2"
"""CURSOR_HAND: 手型光标 / Hand cursor"""

CURSOR_XTERM = "xterm"
"""CURSOR_XTERM: 文本输入光标 / Text input cursor"""

CURSOR_CROSSHAIR = "crosshair"
"""CURSOR_CROSSHAIR: 十字光标 / Crosshair cursor"""

CURSOR_WAIT = "watch"
"""CURSOR_WAIT: 等待光标 / Wait cursor"""

CURSOR_SIZE_NW_SE = "size_nw_se"
"""CURSOR_SIZE_NW_SE: 西北-东南调整光标 / NW-SE resize cursor"""

CURSOR_SIZE_NE_SW = "size_ne_sw"
"""CURSOR_SIZE_NE_SW: 东北-西南调整光标 / NE-SW resize cursor"""

CURSOR_SIZE_HOR = "sb_h_double_arrow"
"""CURSOR_SIZE_HOR: 水平调整光标 / Horizontal resize cursor"""

CURSOR_SIZE_VER = "sb_v_double_arrow"
"""CURSOR_SIZE_VER: 垂直调整光标 / Vertical resize cursor"""


# Widget states
STATE_NORMAL = "normal"
"""STATE_NORMAL: 控件可用状态 / Widget is enabled and interactive"""

STATE_DISABLED = "disabled"
"""STATE_DISABLED: 控件禁用状态 / Widget is disabled"""

STATE_READONLY = "readonly"
"""STATE_READONLY: 控件只读状态 / Widget is read-only"""


# Widget anchor positions
ANCHOR_CENTER = "center"
"""ANCHOR_CENTER: 居中对齐 / Center alignment"""

ANCHOR_N = "n"
"""ANCHOR_N: 北对齐（上） / North (top) alignment"""

ANCHOR_S = "s"
"""ANCHOR_S: 南对齐（下） / South (bottom) alignment"""

ANCHOR_E = "e"
"""ANCHOR_E: 东对齐（右） / East (right) alignment"""

ANCHOR_W = "w"
"""ANCHOR_W: 西对齐（左） / West (left) alignment"""

ANCHOR_NE = "ne"
"""ANCHOR_NE: 东北对齐 / Northeast alignment"""

ANCHOR_NW = "nw"
"""ANCHOR_NW: 西北对齐 / Northwest alignment"""

ANCHOR_SE = "se"
"""ANCHOR_SE: 东南对齐 / Southeast alignment"""

ANCHOR_SW = "sw"
"""ANCHOR_SW: 西南对齐 / Southwest alignment"""


# Layout expand options
EXPAND_BOTH = "both"
"""EXPAND_BOTH: 同时扩展 / Expand both horizontally and vertically"""

EXPAND_X = "x"
"""EXPAND_X: 横向扩展 / Expand horizontally"""

EXPAND_Y = "y"
"""EXPAND_Y: 纵向扩展 / Expand vertically"""


# Layout fill options
FILL_X = "x"
"""FILL_X: 横向填充 / Fill horizontally"""

FILL_Y = "y"
"""FILL_Y: 纵向填充 / Fill vertically"""

FILL_BOTH = "both"
"""FILL_BOTH: 横纵填充 / Fill both directions"""

FILL_NONE = "none"
"""FILL_NONE: 不填充 / No fill"""


# Layout side options
SIDE_TOP = "top"
"""SIDE_TOP: 顶部排列 / Pack to the top"""

SIDE_BOTTOM = "bottom"
"""SIDE_BOTTOM: 底部排列 / Pack to the bottom"""

SIDE_LEFT = "left"
"""SIDE_LEFT: 左侧排列 / Pack to the left"""

SIDE_RIGHT = "right"
"""SIDE_RIGHT: 右侧排列 / Pack to the right"""


# Justify options
JUSTIFY_LEFT = "left"
"""JUSTIFY_LEFT: 左对齐 / Left justify"""

JUSTIFY_CENTER = "center"
"""JUSTIFY_CENTER: 居中对齐 / Center justify"""

JUSTIFY_RIGHT = "right"
"""JUSTIFY_RIGHT: 右对齐 / Right justify"""


# Relief styles
RELIEF_RAISED = "raised"
"""RELIEF_RAISED: 凸起边框样式 / Raised relief style"""

RELIEF_SUNKEN = "sunken"
"""RELIEF_SUNKEN: 凹陷边框样式 / Sunken relief style"""

RELIEF_FLAT = "flat"
"""RELIEF_FLAT: 平直边框样式 / Flat relief style"""

RELIEF_GROOVE = "groove"
"""RELIEF_GROOVE: 沟槽边框样式 / Groove relief style"""

RELIEF_RIDGE = "ridge"
"""RELIEF_RIDGE: 山脊边框样式 / Ridge relief style"""

RELIEF_SOLID = "solid"
"""RELIEF_SOLID: 实线边框样式 / Solid relief style"""


# Other useful constants
YES = "yes"
"""YES: Tkinter 中的“是”值 / 'yes' in Tkinter layout options"""

NO = "no"
"""NO: Tkinter 中的“否”值 / 'no' in Tkinter layout options"""

TRUE = "1"
"""TRUE: Tkinter 中的“真”值 / '1' as True in Tkinter"""

FALSE = "0"
"""FALSE: Tkinter 中的“假”值 / '0' as False in Tkinter"""

DEFAULT = "default"
"""DEFAULT: Tkinter 中默认选项 / Default option in Tkinter"""